diff -uNrd -x CVS ircd-hybrid-7rc5/src/fdlist.c ircd-hybrid-7-bg/src/fdlist.c
--- ircd-hybrid-7rc5/src/fdlist.c	Sat Jun 15 03:19:56 2002
+++ ircd-hybrid-7-bg/src/fdlist.c	Tue Feb  4 11:13:06 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: fdlist.c,v 7.31 2002/06/15 07:19:56 androsyn Exp $
+ *  $Id: fdlist.c,v 1.3 2003/02/04 16:13:06 demond Exp $
  */
 #include "stdinc.h"
 #include "config.h"  /* option settings */
@@ -81,7 +81,7 @@
 
 /* Called to open a given filedescriptor */
 void
-fd_open(int fd, unsigned int type, const char *desc)
+fd_open(int fd, unsigned int type, const char *desc, void *ssl)
 {
   fde_t *F = &fd_table[fd];
   assert(fd >= 0);
@@ -111,6 +111,9 @@
   if (desc)
     strncpy(F->desc, desc, FD_DESC_SZ);
   number_fd++;
+#ifdef HAVE_LIBCRYPTO
+  F->ssl = (SSL *)ssl;
+#endif
 }
 
 
@@ -139,6 +142,17 @@
   number_fd--;
   memset(F, '\0', sizeof(fde_t));
   F->timeout = 0;
+  
+#ifdef HAVE_LIBCRYPTO
+  F->flags.accept_read = 0;
+  F->flags.accept_write = 0;
+  F->accept_failures = 0;
+  if (F->ssl) {
+  	SSL_shutdown(F->ssl);
+  	SSL_free(F->ssl);
+  	F->ssl = NULL;
+  }
+#endif
   /* Unlike squid, we're actually closing the FD here! -- adrian */
   close(fd);
 }
diff -uNrd -x CVS ircd-hybrid-7rc5/src/fileio.c ircd-hybrid-7-bg/src/fileio.c
--- ircd-hybrid-7rc5/src/fileio.c	Thu May 30 21:35:40 2002
+++ ircd-hybrid-7-bg/src/fileio.c	Thu Jan 30 10:28:59 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: fileio.c,v 7.23 2002/05/31 01:35:40 androsyn Exp $
+ *  $Id: fileio.c,v 1.2 2003/01/30 15:28:59 demond Exp $
  */
 #include "stdinc.h"
 #include "config.h"
@@ -49,7 +49,7 @@
         errno = ENFILE;
         fd = -1;
     } else if (fd >= 0)
-        fd_open(fd, FD_FILE, filename);
+        fd_open(fd, FD_FILE, filename, NULL);
     
     return fd;
 }
diff -uNrd -x CVS ircd-hybrid-7rc5/src/getopt.c ircd-hybrid-7-bg/src/getopt.c
--- ircd-hybrid-7rc5/src/getopt.c	Fri May 24 19:34:46 2002
+++ ircd-hybrid-7-bg/src/getopt.c	Mon Dec 30 23:07:26 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: getopt.c,v 7.14 2002/05/24 23:34:46 androsyn Exp $
+ *  $Id: getopt.c,v 1.1.1.1 2002/12/31 04:07:26 demond Exp $
  */
 
 #include "stdinc.h"
diff -uNrd -x CVS ircd-hybrid-7rc5/src/hash.c ircd-hybrid-7-bg/src/hash.c
--- ircd-hybrid-7rc5/src/hash.c	Mon Oct 28 16:09:23 2002
+++ ircd-hybrid-7-bg/src/hash.c	Mon Mar 10 01:09:04 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: hash.c,v 7.47 2002/10/28 21:09:23 bill Exp $
+ *  $Id: hash.c,v 1.4 2003/03/10 06:09:04 demond Exp $
  */
 
 #include "stdinc.h"
@@ -787,8 +787,405 @@
   return(NULL);
 }  
 
+/*
+ * services stuff...	-demond
+ */
+void clear_svs_client_hash_table()
+{
+  int i;
+  struct Client* tmp;
+
+  for (i=0; i < U_MAX; i++)
+    if (tmp = (struct Client*)clientTable[i].list)
+      for (; tmp; tmp = tmp->hnext) {
+      	if (tmp->svsflags & FLAGS_SVS_IDENT)
+        	if (--Count.identified < 0)
+        		Count.identified = 0;
+        		
+		tmp->svsflags = 0;
+	  }
+}
+
+void do_local_clients(void (*func)(), char *mask, void *data)
+{
+  int i;
+  struct Client* tmp;
+
+  for (i=0; i < U_MAX; i++)
+    if (tmp = (struct Client*)clientTable[i].list)
+      for (; tmp; tmp = tmp->hnext)
+		if (MyClient(tmp) && match(mask, tmp->name))
+			func(tmp, data);		
+}
+
+void do_channel_local(void (*func)(), char *chan, void *data)
+{
+	int i, num = 0;
+	dlink_node *ptr;
+	dlink_list *lists[10];
+	struct Channel *chptr;
+	
+	if (!(chptr = hash_find_channel(chan)))
+		return;
+	
+	lists[num++] = &chptr->locpeons;
+	lists[num++] = &chptr->locvoiced;
+#ifdef HALFOPS
+	lists[num++] = &chptr->lochalfops;
+#endif
+#ifdef REQUIRE_OANDV
+	lists[num++] = &chptr->locchanops_voiced;
+#endif
+	lists[num++] = &chptr->locchanops;
+
+	for (i=0; i < num; i++)
+		DLINK_FOREACH(ptr, lists[i]->head)
+			func(ptr->data, data);
+}
+
+int services_present()
+{
+  int i;
+  struct Client* tmp;
+
+  for (i=0; i < U_MAX; i++)
+    if (tmp = (struct Client*)clientTable[i].list)
+      for (; tmp; tmp = tmp->hnext)
+		if (IsServer(tmp))
+          if (find_z_conf(tmp->name))
+            return 1;
+  
+  return 0;
+}
+
+struct Client* find_services()
+{
+  unsigned int hashv;
+  struct ConfItem *aconf;
+  struct Client *tmp;
+
+  extern struct ConfItem *z_conf;
+  for (aconf = z_conf; aconf; aconf = aconf->next)
+    {
+      if (BadPtr(aconf->name))
+		continue;
+
+      hashv = hash_nick_name(aconf->name);
+      tmp = (struct Client*) clientTable[hashv].list;
+
+      for (; tmp; tmp = tmp->hnext)
+		{
+	  	  if (!IsServer(tmp)) 
+	        continue;
+	  	  if (irccmp(aconf->name, tmp->name) == 0)
+	        return tmp;
+		}
+    }
+
+  return NULL;
+}
+
+/*
+ *	shamelessly stolen from bahamut				
+ *						-demond
+ */
+
+/*
+ * Rough figure of the datastructures for notify:
+ *
+ * NOTIFY HASH      cptr1
+ *   |                |- nick1
+ * nick1-|- cptr1     |- nick2
+ *   |   |- cptr2                cptr3
+ *   |   |- cptr3   cptr2          |- nick1
+ *   |                |- nick1
+ * nick2-|- cptr2     |- nick2
+ *       |- cptr1
+ *
+ * add-to-notify-hash-table:
+ * del-from-notify-hash-table:
+ * hash-del-notify-list:
+ * hash-check-notify:
+ * hash-get-notify:
+ */
+
+static   aWatch  *watchTable[WATCHHASHSIZE];
 
+void  count_watch_memory(int *count, u_long *memory)
+{
+    int   i = WATCHHASHSIZE;
+    aWatch  *anptr;
+    
+    
+    while (i--)
+    {
+	anptr = watchTable[i];
+	while (anptr)
+	{
+	    (*count)++;
+	    (*memory) += sizeof(aWatch)+strlen(anptr->nick);
+	    anptr = anptr->hnext;
+	}
+    }
+}
+
+void clear_watch_hash_table(void)
+{
+    memset((char *)watchTable, '\0', sizeof(watchTable));
+}
 
 
+/* add_to_watch_hash_table */
+int   add_to_watch_hash_table(char *nick, aClient *cptr)
+{
+    int   hashv;
+    aWatch  *anptr;
+    Link  *lp;
+    
+    
+    /* Get the right bucket... */
+    hashv = hash_nick_name(nick)%WATCHHASHSIZE;
+    
+    /* Find the right nick (header) in the bucket, or NULL... */
+    if ((anptr = (aWatch *)watchTable[hashv]))
+	while (anptr && irccmp(anptr->nick, nick))
+	    anptr = anptr->hnext;
+    
+    /* If found NULL (no header for this nick), make one... */
+    if (!anptr)
+    {
+	anptr = (aWatch *)MyMalloc(sizeof(aWatch)+strlen(nick));
+	anptr->lasttime = CurrentTime;
+	strcpy(anptr->nick, nick);
+	
+	anptr->watch = NULL;
+	
+	anptr->hnext = watchTable[hashv];
+	watchTable[hashv] = anptr;
+    }
+    /* Is this client already on the watch-list? */
+    if ((lp = anptr->watch))
+	while (lp && (lp->value.cptr != cptr))
+	    lp = lp->next;
+    
+    /* No it isn't, so add it in the bucket and client addint it */
+    if (!lp)
+    {
+	lp = anptr->watch;
+	anptr->watch = (Link *)MyMalloc(sizeof(Link));
+	anptr->watch->value.cptr = cptr;
+	anptr->watch->next = lp;
+	
+	lp = (Link *)MyMalloc(sizeof(Link));
+	lp->next = cptr->watch;
+	lp->value.wptr = anptr;
+	cptr->watch = lp;
+	cptr->watches++;
+    }
+    
+    return 0;
+}
+
+/* hash_check_watch */
+int hash_check_watch(aClient *cptr, int reply)
+{
+    int   hashv;
+    aWatch  *anptr;
+    Link  *lp;
+    
+    
+    /* Get us the right bucket */
+    hashv = hash_nick_name(cptr->name)%WATCHHASHSIZE;
+	
+    /* Find the right header in this bucket */
+    if ((anptr = (aWatch *)watchTable[hashv]))
+	while (anptr && irccmp(anptr->nick, cptr->name))
+	    anptr = anptr->hnext;
+    if (!anptr)
+	return 0;   /* This nick isn't on watch */
+    
+    /* Update the time of last change to item */
+    anptr->lasttime = CurrentTime;
+    
+    /* Send notifies out to everybody on the list in header */
+    for (lp = anptr->watch; lp; lp = lp->next)
+	sendto_one(lp->value.cptr, form_str(lp->value.cptr,reply), me.name,
+		   lp->value.cptr->name, cptr->name,
+		   (IsPerson(cptr)?cptr->username:"<N/A>"),
+		   (IsPerson(cptr)?cptr->host:"<N/A>"),
+		   anptr->lasttime, cptr->info);
+    
+    return 0;
+}
+
+/* hash_get_watch */
+aWatch  *hash_get_watch(char *name)
+{
+    int   hashv;
+    aWatch  *anptr;
+    
+    
+    hashv = hash_nick_name(name)%WATCHHASHSIZE;
+    
+    if ((anptr = (aWatch *)watchTable[hashv]))
+	while (anptr && irccmp(anptr->nick, name))
+	    anptr = anptr->hnext;
+    
+    return anptr;
+}
+
+/* del_from_watch_hash_table */
+int   del_from_watch_hash_table(char *nick, aClient *cptr)
+{
+    int   hashv;
+    aWatch  *anptr, *nlast = NULL;
+    Link  *lp, *last = NULL;
+    
+    
+    /* Get the bucket for this nick... */
+    hashv = hash_nick_name(nick)%WATCHHASHSIZE;
+    
+    /* Find the right header, maintaining last-link pointer... */
+    if ((anptr = (aWatch *)watchTable[hashv]))
+	while (anptr && irccmp(anptr->nick, nick))
+	{
+	    nlast = anptr;
+	    anptr = anptr->hnext;
+	}
+    if (!anptr)
+	return 0;   /* No such watch */
+    
+    /* Find this client from the list of notifies... with last-ptr. */
+    if ((lp = anptr->watch))
+	while (lp && (lp->value.cptr != cptr))
+	{
+	    last = lp;
+	    lp = lp->next;
+	}
+    if (!lp)
+	return 0;   /* No such client to watch */
+    
+    /* Fix the linked list under header, then remove the watch entry */
+    if (!last)
+	anptr->watch = lp->next;
+    else
+	last->next = lp->next;
+    MyFree(lp);
+    
+    /* Do the same regarding the links in client-record... */
+    last = NULL;
+    if ((lp = cptr->watch))
+	while (lp && (lp->value.wptr != anptr))
+	{
+	    last = lp;
+	    lp = lp->next;
+	}
+    
+    /*
+     * Give error on the odd case... probobly not even neccessary
+     * No error checking in ircd is unneccessary ;) -Cabal95
+     */
+    if (!lp)
+	sendto_realops_flags(FLAGS_DEBUG, L_ALL,
+	       "WATCH debug error: del_from_watch_hash_table "
+		   "found a watch entry with no client "
+		   "counterpoint processing nick %s on client %s!",
+		   nick, cptr->user);
+    else
+    {
+	if (!last) /* First one matched */
+	    cptr->watch = lp->next;
+	else
+	    last->next = lp->next;
+	MyFree(lp);
+    }
+    /* In case this header is now empty of notices, remove it */
+    if (!anptr->watch)
+    {
+	if (!nlast)
+	    watchTable[hashv] = anptr->hnext;
+	else
+	    nlast->hnext = anptr->hnext;
+	MyFree(anptr);
+    }
+    
+    /* Update count of notifies on nick */
+    cptr->watches--;
+    
+    return 0;
+}
+
+/* hash_del_watch_list */
+int   hash_del_watch_list(aClient *cptr)
+{
+    int   hashv;
+    aWatch  *anptr;
+    Link  *np, *lp, *last;
+    
+    
+    if (!(np = cptr->watch))
+	return 0;   /* Nothing to do */
+    
+    cptr->watch = NULL; /* Break the watch-list for client */
+    while (np)
+    {
+	/* Find the watch-record from hash-table... */
+	anptr = np->value.wptr;
+	last = NULL;
+	for (lp = anptr->watch; lp && (lp->value.cptr != cptr);
+	     lp = lp->next)
+	    last = lp;
+	
+	/* Not found, another "worst case" debug error */
+	if (!lp)
+	    sendto_realops_flags(FLAGS_DEBUG, L_ALL,
+	           "WATCH Debug error: hash_del_watch_list "
+		       "found a WATCH entry with no table "
+		       "counterpoint processing client %s!",
+		       cptr->name);
+	else
+	{
+	    /* Fix the watch-list and remove entry */
+	    if (!last)
+		anptr->watch = lp->next;
+	    else
+		last->next = lp->next;
+	    MyFree(lp);
+	    
+	    /*
+	     * If this leaves a header without notifies,
+	     * remove it. Need to find the last-pointer!
+	     */
+	    if (!anptr->watch)
+	    {
+		aWatch  *np2, *nl;
+		
+		hashv = hash_nick_name(anptr->nick)%WATCHHASHSIZE;
+		
+		nl = NULL;
+		np2 = watchTable[hashv];
+		while (np2 != anptr)
+		{
+		    nl = np2;
+		    np2 = np2->hnext;
+		}
+		
+		if (nl)
+		    nl->hnext = anptr->hnext;
+		else
+		    watchTable[hashv] = anptr->hnext;
+		MyFree(anptr);
+	    }
+	}
+	
+	lp = np; /* Save last pointer processed */
+	np = np->next; /* Jump to the next pointer */
+	MyFree(lp); /* Free the previous */
+    }
+    
+    cptr->watches = 0;
+    
+    return 0;
+}
 
 
diff -uNrd -x CVS ircd-hybrid-7rc5/src/hook.c ircd-hybrid-7-bg/src/hook.c
--- ircd-hybrid-7rc5/src/hook.c	Wed Oct 30 22:12:30 2002
+++ ircd-hybrid-7-bg/src/hook.c	Mon Dec 30 23:07:26 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: hook.c,v 7.19 2002/10/31 03:12:30 wiz Exp $
+ *  $Id: hook.c,v 1.1.1.1 2002/12/31 04:07:26 demond Exp $
  */
 
 /* hooks are used by modules to hook into events called by other parts of
diff -uNrd -x CVS ircd-hybrid-7rc5/src/hostmask.c ircd-hybrid-7-bg/src/hostmask.c
--- ircd-hybrid-7rc5/src/hostmask.c	Wed Sep 11 11:27:08 2002
+++ ircd-hybrid-7-bg/src/hostmask.c	Mon Mar 10 01:09:04 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: hostmask.c,v 7.73 2002/09/11 15:27:08 db Exp $
+ *  $Id: hostmask.c,v 1.2 2003/03/10 06:09:04 demond Exp $
  */
 
 #include "stdinc.h"
@@ -380,7 +380,7 @@
  */
 struct ConfItem *
 find_conf_by_address(const char *name, struct irc_inaddr *addr, int type,
-                     int fam, const char *username)
+                     int fam, const char *username, char *passwd)
 {
   unsigned long hprecv = 0;
   struct ConfItem *hprec = NULL;
@@ -406,6 +406,9 @@
               (type & 0x1 || match(arec->username, username)) &&
               arec->precedence > hprecv)
           {
+			if (passwd && IsConfSkipOnPassFail(arec->aconf) 
+			&& !BadPtr(arec->aconf->passwd) && strcmp(passwd, arec->aconf->passwd))
+	  			continue;
             hprecv = arec->precedence;
             hprec = arec->aconf;
           }
@@ -425,6 +428,9 @@
               (type & 0x1 || match(arec->username, username)) &&
               arec->precedence > hprecv)
           {
+			if (passwd && IsConfSkipOnPassFail(arec->aconf) 
+			&& !BadPtr(arec->aconf->passwd) && strcmp(passwd, arec->aconf->passwd))
+	  			continue;
             hprecv = arec->precedence;
             hprec = arec->aconf;
           }
@@ -446,6 +452,9 @@
             (type & 0x1 || match(arec->username, username)) &&
             (arec->precedence > hprecv))
         {
+      	  if (passwd && IsConfSkipOnPassFail(arec->aconf) 
+      	  && !BadPtr(arec->aconf->passwd) && strcmp(passwd, arec->aconf->passwd))
+			continue;
           hprecv = arec->precedence;
           hprec = arec->aconf;
         }
@@ -462,6 +471,9 @@
           (type & 0x1 || match(arec->username, username)) &&
           arec->precedence > hprecv)
       {
+     	if (passwd && IsConfSkipOnPassFail(arec->aconf) 
+     	&& !BadPtr(arec->aconf->passwd) && strcmp(passwd, arec->aconf->passwd))
+       	  continue;
         hprecv = arec->precedence;
         hprec = arec->aconf;
       }
@@ -477,12 +489,12 @@
  */
 struct ConfItem *
 find_address_conf(const char *host, const char *user,
-                  struct irc_inaddr *ip, int aftype)
+                  struct irc_inaddr *ip, int aftype, char *passwd)
 {
   struct ConfItem *iconf, *kconf;
 
   /* Find the best I-line... If none, return NULL -A1kmm */
-  if (!(iconf = find_conf_by_address(host, ip, CONF_CLIENT, aftype, user)))
+  if (!(iconf = find_conf_by_address(host, ip, CONF_CLIENT, aftype, user, passwd)))
     return NULL;
 
   /* If they are exempt from K-lines, return the best I-line. -A1kmm */
@@ -490,7 +502,7 @@
     return iconf;
 
   /* Find the best K-line... -A1kmm */
-  kconf = find_conf_by_address(host, ip, CONF_KILL, aftype, user);
+  kconf = find_conf_by_address(host, ip, CONF_KILL, aftype, user, NULL);
 
   /* If they are K-lined, return the K-line. Otherwise, return the
    * I-line. -A1kmm */
@@ -515,7 +527,7 @@
   struct ConfItem *kconf;
 
   /* Find the best K-line... -A1kmm */
-  kconf = find_conf_by_address(host, ip, CONF_KILL, aftype, user);
+  kconf = find_conf_by_address(host, ip, CONF_KILL, aftype, user, NULL);
 
   /* If they are K-lined, return the K-line. Otherwise, return the
    * I-line. -A1kmm */
@@ -533,10 +545,11 @@
 {
   struct ConfItem *eline;
   eline = find_conf_by_address(NULL, addr, CONF_EXEMPTDLINE | 1, aftype,
-                               NULL);
+                               NULL, NULL);
   if (eline)
     return eline;
-  return find_conf_by_address(NULL, addr, CONF_DLINE | 1, aftype, NULL);
+  return find_conf_by_address(NULL, addr, CONF_DLINE | 1, aftype, 
+  							  NULL, NULL);
 }
 
 /* void add_conf_by_address(const char*, int, const char *,
@@ -746,7 +759,7 @@
         /* We are doing a partial list, based on what matches the u@h of the
          * sender, so prepare the strings for comparing --fl_ */
 
-        sendto_one(client_p, form_str(RPL_STATSILINE), me.name,
+        sendto_one(client_p, form_str(client_p,RPL_STATSILINE), me.name,
                    client_p->name, (IsConfRestricted(aconf)) ? 'i' : 'I', name,
                    show_iline_prefix(client_p, aconf, user),
 #ifdef HIDE_SPOOF_IPS
@@ -786,7 +799,7 @@
           continue;
         get_printable_conf(aconf, &name, &host, &pass, &user, &port,
                            &classname);
-        sendto_one(client_p, form_str(RPL_STATSKLINE), me.name,
+        sendto_one(client_p, form_str(client_p,RPL_STATSKLINE), me.name,
                    client_p->name, c, host, user, pass);
       }
 }
diff -uNrd -x CVS ircd-hybrid-7rc5/src/irc_string.c ircd-hybrid-7-bg/src/irc_string.c
--- ircd-hybrid-7rc5/src/irc_string.c	Thu May 30 22:21:03 2002
+++ ircd-hybrid-7-bg/src/irc_string.c	Mon Dec 30 23:07:26 2002
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: irc_string.c,v 7.54 2002/05/31 02:21:03 androsyn Exp $
+ *  $Id: irc_string.c,v 1.1.1.1 2002/12/31 04:07:26 demond Exp $
  */
 
 #include "stdinc.h"
diff -uNrd -x CVS ircd-hybrid-7rc5/src/ircd.c ircd-hybrid-7-bg/src/ircd.c
--- ircd-hybrid-7rc5/src/ircd.c	Mon Oct 28 16:09:24 2002
+++ ircd-hybrid-7-bg/src/ircd.c	Sat May 24 23:27:11 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: ircd.c,v 7.242 2002/10/28 21:09:24 bill Exp $
+ *  $Id: ircd.c,v 1.6 2003/05/24 00:07:46 demond Exp $
  */
 
 #include "stdinc.h"
@@ -114,7 +114,7 @@
 
 char**  myargv;
 int     dorehash   = 0;
-int     debuglevel = -1;        /* Server debug level */
+int     debuglevel = DEBUG_DEBUG;/* Server debug level */
 char*   debugmode  = "";        /*  -"-    -"-   -"-  */
 time_t  nextconnect = 1;        /* time for next try_connections call */
 
@@ -212,12 +212,22 @@
         }
 
       limit.rlim_cur = limit.rlim_max; /* make soft limit the max */
+      printf("Value of limit.rlim_max is %ld\n", (long)limit.rlim_max);
+
       if (setrlimit(RLIMIT_FD_MAX, &limit) == -1)
         {
           fprintf(stderr,"error setting max fd's to %ld\n",
                         (long) limit.rlim_cur);
           exit(EXIT_FAILURE);
         }
+      printf("Value of NOFILE is %d\n", NOFILE);
+    }
+
+  if (!getrlimit(RLIMIT_CORE, &limit))
+    {
+      limit.rlim_cur = limit.rlim_max;
+      if (!setrlimit(RLIMIT_CORE, &limit))
+	    printf("Value of corefile size is %lu\n", (unsigned long)limit.rlim_cur);
     }
 #endif        /* RLIMIT_FD_MAX */
 }
@@ -533,12 +543,32 @@
 {
   /* Check to see if the user is running us as root, which is a nono */
   
+  /* well some ppl wanted low ports so...	-demond
   if(geteuid() == 0)
   {
     fprintf(stderr, "Don't run ircd as root!!!\n");
     return -1;
+  }*/
+
+#ifdef USE_GETTEXT
+  /*
+   * For 'locale' try (in this order):
+   *    Config entry "msglocale" (yyparse() will overwrite LANGUAGE)
+   *    Env variable "LANGUAGE"
+   *    Default of "" (so don't overwrite LANGUAGE here)
+   */
+
+  if (!getenv("LANGUAGE"))
+  {
+    putenv("LANGUAGE=");
   }
 
+  setlocale(LC_ALL, "");
+  textdomain("ircd-hybrid");
+  bindtextdomain("ircd-hybrid" , MSGPATH);
+  bindtextdomain("alt-language" , MSGPATH);
+#endif
+
   /*
    * save server boot time right away, so getrusage works correctly
    */
@@ -660,7 +690,24 @@
   initServerMask();
   init_auth();                  /* Initialise the auth code */
   init_resolver();      /* Needs to be setup before the io loop */
+  
+#ifdef HAVE_LIBCRYPTO
+  SSL_load_error_strings();
+  SSLeay_add_ssl_algorithms();
+  ServerInfo.meth = SSLv23_server_method();
+  ServerInfo.ctx = SSL_CTX_new(ServerInfo.meth);
+  if (!ServerInfo.ctx) {
+  	fprintf(stderr, "Could not initialize the SSL context -- %s\n",
+  		ERR_error_string(ERR_get_error(), NULL));
+  }
+  SSL_CTX_set_options(ServerInfo.ctx, SSL_OP_NO_SSLv2);
+  SSL_CTX_set_options(ServerInfo.ctx, SSL_OP_TLS_ROLLBACK_BUG|SSL_OP_ALL);
+  /*SSL_CTX_set_verify(ServerInfo.ctx, SSL_VERIFY_PEER|SSL_VERIFY_CLIENT_ONCE, NULL);*/
+  SSL_CTX_set_verify(ServerInfo.ctx, SSL_VERIFY_NONE, NULL);
+#endif
+
   read_conf_files(YES);         /* cold start init conf files */
+
 #ifndef STATIC_MODULES
 
   mod_add_path(IRCD_PREFIX "/modules");
@@ -692,23 +739,6 @@
   }
   strncpy(me.info, ServerInfo.description, REALLEN);
 
-#ifdef USE_GETTEXT
-  /*
-   * For 'locale' try (in this order):
-   *    Config entry "msglocale" (yyparse() will overwrite LANGUAGE)
-   *    Env variable "LANGUAGE"
-   *    Default of "" (so don't overwrite LANGUAGE here)
-   */
-
-  if (!getenv("LANGUAGE"))
-  {
-    putenv("LANGUAGE=");
-  }
-
-  textdomain("ircd-hybrid");
-  bindtextdomain("ircd-hybrid" , MSGPATH);
-#endif
-
 #ifdef USE_IAUTH
   iAuth.flags = 0;
 
@@ -736,6 +766,14 @@
   
   ilog(L_NOTICE, "Server Ready");
   
+  eventAdd("pace_channels", pace_channels, NULL, PACE_CHANNELS_TIME);
+
+  eventAdd("check_warn_drone", check_warn_drone, NULL, CHECK_DRONE_TIME);
+
+  eventAdd("check_drone_queue", check_drone_queue, NULL, ConfigFileEntry.drone_rate_period);
+
+  eventAdd("purge_repeats", purge_repeats, NULL, ConfigFileEntry.repeat_grace);
+  
   eventAddIsh("cleanup_glines", cleanup_glines, NULL, CLEANUP_GLINES_TIME);
 
   eventAddIsh("cleanup_tklines", cleanup_tklines, NULL, CLEANUP_TKLINES_TIME);
@@ -763,6 +801,8 @@
 
   if(splitmode)
     eventAddIsh("check_splitmode", check_splitmode, NULL, 60);
+
+  fflush(stdout);
 
   ServerRunning = 1;
   io_loop();
diff -uNrd -x CVS ircd-hybrid-7rc5/src/ircd_lexer.l ircd-hybrid-7-bg/src/ircd_lexer.l
--- ircd-hybrid-7rc5/src/ircd_lexer.l	Wed Oct 30 12:44:56 2002
+++ ircd-hybrid-7-bg/src/ircd_lexer.l	Sat May 24 23:27:11 2003
@@ -19,7 +19,7 @@
  *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
  *  USA
  *
- *  $Id: ircd_lexer.l,v 1.146 2002/10/30 17:44:56 wiz Exp $
+ *  $Id: ircd_lexer.l,v 1.4 2003/05/24 00:07:46 demond Exp $
  */
 
 %option case-insensitive
@@ -148,6 +148,8 @@
 compression_level { return COMPRESSION_LEVEL; }
 connect		{ return CONNECT; }
 connectfreq     { return CONNECTFREQ; }
+cyrillic        { return CYRILLIC; }
+totaltrans      { return TOTALTRANS; }
 cryptlink	{ return CRYPTLINK; }
 default_cipher_preference { return DEFAULT_CIPHER_PREFERENCE; }
 default_floodcount  { return DEFAULT_FLOODCOUNT; }
@@ -172,6 +174,7 @@
 fname_foperlog  { return FNAME_FOPERLOG; }
 fname_operlog   { return FNAME_OPERLOG; }
 fname_userlog   { return FNAME_USERLOG; }
+netid		{ return NETID; }
 gecos		{ return GECOS; }
 general		{ return GENERAL; }
 gline		{ return GLINE; }
@@ -184,6 +187,7 @@
 hidden		{ return HIDDEN; }
 hide_servers	{ return HIDE_SERVERS; }
 host		{ return HOST; }
+maskhost	{ return MASKHOST; }
 hub		{ return HUB; }
 hub_mask	{ return HUB_MASK; }
 idletime        { return IDLETIME; }
@@ -233,6 +237,7 @@
 ping_cookie	{ return PING_COOKIE; }
 ping_time	{ return PING_TIME; }
 port		{ return PORT; }
+sslport		{ return SSLPORT; }
 quiet_on_ban    { return QUIET_ON_BAN; }
 reason		{ return REASON; }
 redirport       { return REDIRPORT; }
@@ -244,13 +249,16 @@
 resv		{ return RESV; }
 rsa_private_key_file		{ return RSA_PRIVATE_KEY_FILE; }
 rsa_public_key_file		{ return RSA_PUBLIC_KEY_FILE; }
+ssl_certificate_file	{ return SSL_CERTIFICATE_FILE; }
 send_password	{ return SEND_PASSWORD; }
 sendq		{ return SENDQ; }
 serverhide	{ return SERVERHIDE; }
 serverinfo	{ return SERVERINFO; }
+services        { return SERVICES; }
 servlink_path   { return SERVLINK_PATH; }
 shared          { return T_SHARED; }
 short_motd      { return SHORT_MOTD; }
+skip_on_fail    { return SKIP_ON_FAIL; }
 silent          { return SILENT; }
 spoof		{ return SPOOF; }
 spoof_notice	{ return SPOOF_NOTICE; }
@@ -262,6 +270,8 @@
 use_halfops     { return USE_HALFOPS; }
 use_help        { return USE_HELP; }
 use_invex	{ return USE_INVEX; }
+use_subst	{ return USE_SUBST; }
+use_denies	{ return USE_DENIES; }
 use_knock	{ return USE_KNOCK; }
 use_vchans      { return USE_VCHANS; }
 throttle_time { return THROTTLE_TIME; }
@@ -271,6 +281,25 @@
 vhost6	{ return VHOST6; }
 warn		{ return WARN; }
 yes		{ return TYES; }
+equivalent      { return EQUIVALENT; }
+nicks           { return NICKS; }
+relays          { return RELAYS; }
+userpar			{ return USERPAR; }
+param			{ return PARAM; }
+dummy           { return DUMMY; }
+
+drone_rate_max		{ return DRONE_RATE_MAX; }
+drone_rate_period	{ return DRONE_RATE_PERIOD; }
+drone_kline			{ return DRONE_KLINE; }
+drone_batch			{ return DRONE_BATCH; }
+drone_kline_time	{ return DRONE_KLINE_TIME; }
+drone_reason		{ return DREASON; }
+spam_wait			{ return SPAM_WAIT; }
+repeat_grace		{ return REPEAT_GRACE; }
+spawn_pass			{ return SPAWN_PASS; }
+gateway				{ return GATEWAY; }
+clusters			{ return CLUSTERS; }
+bridge				{ return BRIDGE; }
 
 failed_oper_notice      { return FAILED_OPER_NOTICE; }
 max_accept              { return MAX_ACCEPT; }
@@ -282,6 +311,7 @@
 ts_max_delta            { return TS_MAX_DELTA; }
 ts_warn_delta           { return TS_WARN_DELTA; }
 links_delay           { return LINKS_DELAY; }
+grace_time				{ return GRACE_TIME; }
 kline_with_connection_closed { return KLINE_WITH_CONNECTION_CLOSED; }
 kline_with_reason       { return KLINE_WITH_REASON; }
 warn_no_nline           { return WARN_NO_NLINE; }
@@ -312,6 +342,7 @@
 full                    { return T_FULL; }
 skill                   { return T_SKILL; }
 nchange                 { return T_NCHANGE; }
+rconn					{ return T_REMOTE; }
 rej                     { return T_REJ; }
 unauth                  { return T_UNAUTH; }
 spy                     { return T_SPY; }
